<?xml version="1.0"?>

<!--   FILE: struct.xslt - -->
<!-- AUTHOR: W. Michael Petullo (mike@flyn.org) -->
<!--   DATE: 27 June 2002 -->

<!-- Copyright (C) 2002 W. Michael Petullo (mike@flyn.org) -->
<!-- All rights reserved. -->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:output method="text"/>

<xsl:template match="/">
	<xsl:apply-templates/>
</xsl:template>

<xsl:template match="usage">
	<xsl:text>#include &lt;getopt.h&gt;

typedef struct settings_t {
</xsl:text>
	<xsl:apply-templates select="option"/>
	<xsl:apply-templates select="argument"/>
	<xsl:text>} settings_t;

</xsl:text>
</xsl:template>

<xsl:template match="usage/argument">
	<xsl:text>	</xsl:text>
	<xsl:value-of select="type"/>
	<xsl:text> </xsl:text>
	<xsl:value-of select="name"/>
	<xsl:text>;
</xsl:text>
</xsl:template>

<xsl:template match="usage/option">
	<xsl:text>	int </xsl:text>
	<xsl:value-of select="name"/>
	<xsl:text>;
</xsl:text>
</xsl:template>

</xsl:stylesheet>
